<?php
/**
 * @package     ContentBuilder
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

@ob_end_clean();

require_once(JPATH_COMPONENT_ADMINISTRATOR . DS . 'classes' . DS . 'contentbuilder.php');
require_once(JPATH_COMPONENT_ADMINISTRATOR . DS . 'classes' . DS . 'contentbuilder_helpers.php');
require_once(__DIR__.'/../../../classes/PHPExcel.php');
require_once( JPATH_BASE .'/includes/defines.php' );
require_once( JPATH_BASE .'/includes/framework.php' );

$objPHPExcel = new PHPExcel();

$objPHPExcel->getProperties()->setCreator("ContentBuilder")
->setLastModifiedBy("ContentBuilder");
$c = 'A';
$i = 1;
    if($this->data->show_id_column){
    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue("$c"."$i", JText::_('COM_CONTENTBUILDER_ID'));
    $c++;  
    }
    if($this->data->list_state){
	$objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue("$c"."$i", "List state");
    $c++;
    }
    if($this->data->list_publish){
    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue("$c"."$i", "Published");
    $c++;}

    foreach($this->data->visible_labels As $label){
        $cell = "$c"."$i";
        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue($cell, $label); 
        $c++; 
    }

    $ch='A';
    $i=2;
    foreach($this->data->items As $item){
        for($ch='A';$ch<=$c;$ch++){
            if($this->data->show_id_column){
        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue("$ch"."$i", $item->colRecord); 
        $ch++;
            }
        //List state
        if($this->data->list_state){

        $database = JFactory::getDBO();
        $sql = "SELECT title, color FROM `#__contentbuilder_list_states` WHERE id = (SELECT state_id FROM `#__contentbuilder_list_records` WHERE record_id = $item->colRecord)"; // Select data from DB
        $database->setQuery( $sql );
        $result = $database->loadRow();
        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue("$ch"."$i", $result[0]);
        if($result[1] < 1) $result[1] = 'FFFFFF';
        if($result[1] != 'FFFFFF'){
        $sharedStyle1 = new PHPExcel_Style();
$sharedStyle1->applyFromArray(
	array('fill' 	=> array(
								'type'		=> PHPExcel_Style_Fill::FILL_SOLID,
								'color'		=> array('rgb' => $result[1])
							)
		 ));
$objPHPExcel->getActiveSheet()->setSharedStyle($sharedStyle1, "$ch"."$i");
        }
        $ch++;
    }
    
        //Published
        if($this->data->list_publish){
        $database1 = JFactory::getDBO();
        $sql = "SELECT `state` FROM `#__content` WHERE id = (SELECT article_id FROM `#__contentbuilder_articles` WHERE id = $item->colRecord)"; // Select data from DB
        $database1->setQuery( $sql );
        $result = $database1->loadResult();
        if($result == 1){
            $objPHPExcel->setActiveSheetIndex(0)
            ->setCellValue("$ch"."$i", 'Yes');
            }
        else {
            $objPHPExcel->setActiveSheetIndex(0)
            ->setCellValue("$ch"."$i", 'No');
            }
            $ch++;
        }

        foreach($item As $key => $value){
            if($key != 'colRecord' && in_array(str_replace('col','',$key), $this->data->visible_cols)){
                $cell="$ch"."$i";
                    $objPHPExcel->setActiveSheetIndex(0)
                    ->setCellValue($cell, $value);  
                $ch++;
            }
            
        }
        $i++;
        }
    }
    

$objPHPExcel->getDefaultStyle()->getAlignment()->setWrapText(true);
$cell_length = 0;
for($col='A';$col<$ch;$col++){
    for($row=1;$row<$i;$row++){
        $cell="$col"."$row";
        $length = strlen($objPHPExcel->getActiveSheet()->getCell($cell)->getValue());
        if($length > $cell_length){
            $cell_length = $length;
        }
        $objPHPExcel->getActiveSheet()
        ->getStyle($cell)
        ->getNumberFormat()
        ->setFormatCode( PHPExcel_Style_NumberFormat::FORMAT_TEXT ); 
    }
    if($cell_length < 1){
        $width = 15;
    }
    else if($cell_length <= 50){
        $width = $cell_length + 5;
    }
    else {
        $width = $cell_length/3;
    }
    $objPHPExcel->getActiveSheet()->getColumnDimension($col)->setWidth($width);
    $cell_length = 0;
       
}



$objPHPExcel->getActiveSheet()->setTitle("export-".date('Y-m-d_Hi').".xlsx");


$filename = "export-".date('Y-m-d_Hi').".xlsx";
$objPHPExcel->setActiveSheetIndex(0);


// Redirect output to a client’s web browser (Excel5)
header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment; filename=' . $filename);
header('Cache-Control: max-age=0');
// If you're serving to IE 9, then the following may be needed
header('Cache-Control: max-age=1');

// If you're serving to IE over SSL, then the following may be needed
header ('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
header ('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT'); // always modified
header ('Cache-Control: cache, must-revalidate'); // HTTP/1.1
header ('Pragma: public'); // HTTP/1.0

$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter->save('php://output');

exit;
?>